#!/bin/bash - 
#===============================================================================
#
#          FILE: aftiss.sh
# 
#         USAGE: ./aftiss.sh 
# 
#   DESCRIPTION: 
# 
#       OPTIONS: ---
#  REQUIREMENTS: ---
#          BUGS: ---
#         NOTES: ---
#        AUTHOR: YOUR NAME (), 
#  ORGANIZATION: 
#       CREATED: 08/04/17 12:25
#      REVISION:  ---
#===============================================================================

SCRIPT_PATH=`dirname $0`
adbexecut="$SCRIPT_PATH/adb/linux/adb"

set -o nounset                              # Treat unset variables as an error

#colors
red=$(tput setaf 1)             #  red
grn=$(tput setaf 2)             #  green
ylw=$(tput setaf 3)             #  yellow
blu=$(tput setaf 4)             #  blue
ppl=$(tput setaf 5)             #  purple
cya=$(tput setaf 6)             #  cyan
txtbld=$(tput bold)             #  Bold
bldred=${txtbld}$(tput setaf 1) #  red
bldgrn=${txtbld}$(tput setaf 2) #  green
bldylw=${txtbld}$(tput setaf 3) #  yellow
bldblu=${txtbld}$(tput setaf 4) #  blue
bldppl=${txtbld}$(tput setaf 5) #  purple
bldcya=${txtbld}$(tput setaf 6) #  cyan
txtrst=$(tput sgr0)

TITLE="Auto-formatting SDCard to Internal and SDCard storage"

sdcardnon_error (){
        echo  "[ERROR] SDCard not found!"
        exit 1
}

custom (){
        clear
        echo "$TITLE"
        echo
        echo "Enter a value for percentage of internal memory you want, the rest will be used for external storage (sdcard):"
        echo -n "%"
        read VALUE
        st_beg $VALUE
}

st_beg (){
        clear
        smmix="$1"
        echo
        echo  $TITLE
        echo
        echo
        echo - Start ADB Server...
        echo adb start-server
        echo 
        echo Collecting information...
        devdiskinf="$($adbexecut shell sm list-disks adoptable)"
        device="$($adbexecut shell getprop ro.product.model)"
        if [[ $devdiskinf == "" ]]; then
                sdcardnon_error
        fi
        echo
        echo "Device: $device"
        echo - Formatting $devdiskinf...
        $adbexecut shell sm partition $devdiskinf mixed $smmix
        echo
        echo "Done"
}

clear
echo "=================================================================="
echo "$TITLE"
echo
echo   ${grn}Supported devices with Android Marshmallow and higher.
echo   Ensure USB debugging is enabled${red}
echo   ${bldred}-- Attention! You will lose all data on the memory card! --${txtrst}
echo
echo   Select the formatting mode:
echo  [1] - ${blu}Internal${txtrst} [${blu}==${txtrst}${red}--------${txtrst}] ${red}SDCard${txtrst}
echo  [2] - ${blu}Internal${txtrst} [${blu}=====${txtrst}${red}-----${txtrst}] ${red}SDCard${txtrst}
echo  [3] - ${blu}Internal${txtrst} [${blu}========${txtrst}${red}--${txtrst}] ${red}SDCard${txtrst}
echo  [4] - Custom
echo  [Q/q] - Exit
echo
echo "=================================================================="
echo -n "Option: "
read OPT
case $OPT in
        1) st_beg 75 ;;
        2) st_beg 50 ;;
        3) st_beg 25 ;;
        4) custom ;;
        Q|q) exit 0
esac
